/*****************************************************************************/

import java.applet.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;
import java.util.*;
import java.awt.geom.*;

/*****************************************************************************/

class Fenetre extends JFrame
	{
	/* paneaux */
	private CadreImage image;
	private CadreChoix choix;
	private CadrePeon peon;
	private CadreStats stats;
	
	public Fenetre(String titre)
		{
		super(titre);
		Container c = getContentPane();
		c.setLayout(new BorderLayout());
				
		/* menu */
		JMenuBar menu = new JMenuBar();
		setJMenuBar(menu);
        
        /* menu action */        
		JMenu menuAction = new JMenu(Lang.tMenuAction);
		menu.add(menuAction);
		
		JMenuItem mTuer = new JMenuItem(Lang.tTuer);
		menuAction.add(mTuer);
		mTuer.setAccelerator(KeyStroke.getKeyStroke('T', 2));
		mTuer.setMnemonic('T');
		mTuer.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.tuer();}
			});
		mTuer.setToolTipText(Lang.aTuer);
		
		JMenuItem mRevive = new JMenuItem(Lang.tRevive);
		menuAction.add(mRevive);
		mRevive.setAccelerator(KeyStroke.getKeyStroke('R', 2));
		mRevive.setMnemonic('R');
		mRevive.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.revive();}
			});
		mRevive.setToolTipText(Lang.aRevive);
		
		/* menu gestion */
		JMenu menuGestion = new JMenu(Lang.tMenuGestion);
		menu.add(menuGestion);
		
		JMenuItem mNew = new JMenuItem(Lang.tNew);
		menuGestion.add(mNew);
		mNew.setAccelerator(KeyStroke.getKeyStroke('N', 2));
		mNew.setMnemonic('N');
		mNew.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e) {Peon.add();}
			});
		mNew.setToolTipText(Lang.aNew);
		
		JMenuItem mSuppr = new JMenuItem(Lang.tSuppr);
		menuGestion.add(mSuppr);
		mSuppr.setAccelerator(KeyStroke.getKeyStroke('S', 2));
		mSuppr.setMnemonic('S');
		mSuppr.addActionListener(new ActionListener()
			{
			public void actionPerformed(ActionEvent e)	{BarbiePeon.peonCourrant.suppr();}
			});
		mSuppr.setToolTipText(Lang.aSuppr);              
		
        /* paneaux */
        image = new CadreImage();        
		c.add(image, "Center");
		choix = new CadreChoix(image);
		c.add(choix, "South");
		peon = new CadrePeon();
		c.add(peon, "North");
		stats = new CadreStats();        
		c.add(stats, "East");
		}
	
	/* methodes get */
	public CadreImage getImage() {return image;}
	}

/*****************************************************************************/

class CadreChoix extends JPanel
	{
	CadreImage image;
	JButton arme1 = new JButton(Lang.arme);
	JButton arme2 = new JButton(Lang.nArme);

	public CadreChoix(CadreImage image)
		{
		this.image = image;

		setLayout(new FlowLayout());

		arme1.addActionListener(new ActionListener() 
			{
			public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.setImage(FImages.iPeon_R_H);} 
			});
		add(arme1);

		arme2.addActionListener(new ActionListener() 
			{
			public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant.setImage(FImages.iPeon_R_N);} 
			});
		add(arme2);
		}
	/*
	public CadreChoix()
		{
		setLayout(new FlowLayout());

		JComboBox coulTenue = new JComboBox(Lang.liste_coulTenue);
		add(coulTenue);

		JCheckBox arme = new JCheckBox(Lang.arme, false);
		add(arme);

		JButton ok = new JButton("OK");
		add(ok);
		}
	*/
	}

/*****************************************************************************/

class CadrePeon extends JPanel
	{
	public CadrePeon()
		{
		setLayout(new FlowLayout());

		JLabel peonT = new JLabel(Lang.votrePeon);
		add(peonT);
		}
	}

/*****************************************************************************/

class CadreImage extends JPanel
	{
	public CadreImage()
		{
		}
	}

/*****************************************************************************/

class CadreStats extends JPanel
	{
	public CadreStats()
		{
		}

	public void paint(Graphics g)
		{
		}
	}

/*****************************************************************************/

class Peon implements ActionListener
	{
	private JButton image;
	private boolean vivant;
	/* stats */
	private int nbMorts;
	private String nom;

	public Peon()
		{
		image = new JButton(FImages.iPeon_R_N);
		image.addActionListener(this);
		image.setBackground(Color.black);
		vivant = true;
		nbMorts = 0;
		}

	public void tuer() 
		{
		if(vivant())
			{
			vivant = false; 
			image.setIcon(FImages.iPeon_R_M);
			nbMorts++;
			}
		else 
			{ 
			JOptionPane.showMessageDialog(null, Lang.erPeonMort, Lang.erTitre, JOptionPane.ERROR_MESSAGE); 
			} 
		}
        
	public void revive() 
		{
		if(!BarbiePeon.peonCourrant.vivant())
			{
			vivant = true; 
			image.setIcon(FImages.iPeon_R_N);
			}
		else 
			{ 
			JOptionPane.showMessageDialog(null, Lang.erPeonVivant, Lang.erTitre, JOptionPane.ERROR_MESSAGE); 
			}
		}
	
	public void suppr()
		{
		if(BarbiePeon.peons.size()>1) 
			{
			BarbiePeon.peons.remove(BarbiePeon.peons.indexOf(this));
			BarbiePeon.peonCourrant = (Peon)BarbiePeon.peons.get(0);
			BarbiePeon.fen.getImage().remove(getImage());
			BarbiePeon.fen.getImage().validate();
			}
		else {JOptionPane.showMessageDialog(null, Lang.erPeonSeul, Lang.erTitre, JOptionPane.ERROR_MESSAGE);}
		}
	
	public static void add()
		{
		BarbiePeon.peonCourrant = new Peon();
		BarbiePeon.peons.add(BarbiePeon.peonCourrant);
		BarbiePeon.fen.getImage().add(BarbiePeon.peonCourrant.getImage());
		BarbiePeon.fen.getImage().validate();
		}
	
	public void actionPerformed(ActionEvent e) {BarbiePeon.peonCourrant = this;}
	
	/* methodes set */
	public void setImage(ImageIcon icon)
		{
		if(vivant()) {image.setIcon(icon);}
		else {JOptionPane.showMessageDialog(null, Lang.erPeonMort, Lang.erTitre, JOptionPane.ERROR_MESSAGE);}
		}
	
	/* methodes get */	
	public boolean vivant()	{return vivant;}
	public JButton getImage() {return image;}
		
	}

/*****************************************************************************/

public class BarbiePeon
	{
	static int largeurFenetre = 500;
	static int hauteurFenetre = 220;
	static ArrayList peons;
	static Peon peonCourrant;
	static Fenetre fen;

	public static void main(String[] args)
		{
		JOptionPane.showMessageDialog(null, Lang.about_message, Lang.about_titre, JOptionPane.INFORMATION_MESSAGE);
		fen = new Fenetre(Lang.fenTitre);
		
		peons = new ArrayList();	
		Peon.add();
		
				
		fen.setBounds(150, 200, largeurFenetre, hauteurFenetre);
		fen.setVisible(true);
		}
	}

/*****************************************************************************/

class Lang
	{
	/* dans BarbiePeon */
	static String fenTitre = "Barbie-Peon (Beta version 0.3)";
	static String about_titre = "About "+fenTitre;
	static String about_message = "Barbie-Peon est un logiciel indispenssable par excellence ! "+
	" En effet, il permet d'habiller des peons, comme de vraies poupes !"+
	"\n\nLiscence d'utilisation : \n"+
	"- Ce logiciel est (trs)Cherware. "+
	"Si vous l'utilisez plus de 10 secondes, "+
	"merci de m'envoyer un chque de 75238.\n"+
	"- Le prix indiqu esr videnment par minute"+
	" d'utilsation, mais tais-ce bien utile de le preciser ?";

	/* menu action */
	static String tMenuAction = "Actions";
	static String tTuer = "Tuer";
	static String tRevive = "Ressuciter";
	static String aTuer = "Tuer ce peon.";
	static String aRevive = "Des remords ?";
	/* menu gestion */
	static String tMenuGestion = "Gestion";
	static String tNew = "Nouveau";
	static String tSuppr = "Supprimer";
	static String aNew = "Crer un nouveau peon.";
	static String aSuppr = "Supprimer ce peon.";
        
	/* dans CadreChoix */
	static String[] liste_coulTenue = {"Bleu", "Rouge", "Jaune", "Violet"/*, "Nu"*/};
	static String arme = "Arm";
	static String nArme = "Non arm";

	/* dans CadrePeon */
	static String votrePeon = "Votre peon :\n";

	/* messages d'erreurs */
	static String erTitre = "Action impossible";
	static String erPeonMort = "Impossible, ce peon est mort !";
	static String erPeonVivant = "Impossible, ce peon est encore en vie !";
	static String erPeonSeul = "Vous ne pouvez pas avoi moins d'un peon !";
	}

/*****************************************************************************/

class FImages
	{
	/* Image */
	static Image peonTete = Toolkit.getDefaultToolkit().getImage("peon.gif");
	static Image peon_R_N = Toolkit.getDefaultToolkit().getImage("peon_r_n.gif");
	static Image peon_R_H = Toolkit.getDefaultToolkit().getImage("peon_r_h.gif");
	static Image peon_R_M = Toolkit.getDefaultToolkit().getImage("peon_r_m.gif");
	
	/* ImageIcon */
	static ImageIcon iPeonTete = new ImageIcon("peon.gif");
	static ImageIcon iPeon_R_N = new ImageIcon("peon_r_n.gif");
	static ImageIcon iPeon_R_H = new ImageIcon("peon_r_h.gif");
	static ImageIcon iPeon_R_M = new ImageIcon("peon_r_m.gif");
	}

/*****************************************************************************/
